| DayF core 1.2.1.2 DayF (Decision at your Fingertips) is an AutoML freeware development framework that let developers works with Machine Learning models without any idea of AI, simply taking a csv dataset and the objective column

Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
gdayf.core.adviserbase.Adviser Class Reference

Class focused on execute A* based analysis on three modalities of working Fast: 1 level analysis over default parameters Normal: One A* analysis for all models based until max_deep with early_stopping Paranoiac: One A* algorithm per model analysis until max_deep without early stoping. More...

Inheritance diagram for gdayf.core.adviserbase.Adviser:
[legend]
Collaboration diagram for gdayf.core.adviserbase.Adviser:
[legend]

## Public Member Functions
def | __init__ (self, e_c, deep_impact=5, metric='accuracy', dataframe_name='', hash_dataframe='')
| Constructor. More...
def | set_recommendations (self, dataframe_metadata, objective_column, amode=POC, atype=None)
| Main method oriented to execute smart analysis. More...
def | analysisnormal (self, dataframe_metadata, objective_column, amode)
| Method oriented to execute smart normal and fast analysis. More...
def | analysispoc (self, dataframe_metadata, objective_column, amode)
| Method oriented to execute poc analysis. More...
def | analysis_specific (self, dataframe_metadata, list_ar_metadata)
| Method oriented to execute new analysis. More...
def | analysisparanoiac (self, dataframe_metadata, objective_column, amode)
| Method oriented to execute smart normal and fast analysis. More...
def | analysisanomalies (self, dataframe_metadata, objective_column, amode)
| Method oriented to execute unsupervised anomalies models. More...
def | analysisclustering (self, dataframe_metadata, objective_column, amode)
| Method oriented to execute unsupervised clustering models. More...
def | base_specific (self, dataframe_metadata, list_ar_metadata)
| Method oriented to generate specific candidate metadata. More...
def | base_iteration (self, amode, dataframe_metadata, objective_column)
| Method oriented to select initial candidate models. More...
def | load_frameworks (self)
| Method oriented to get frameworks default values from config. More...
def | get_analysis_objective (self, dataframe_metadata, objective_column, atype=None)
| Method oriented to analyze DFmetadata and select analysis objective. More...
def | get_size_increment (self, df_metadata)
| Method oriented to analyze get increments on effort based on DF_metadata structure. More...
def | get_candidate_models (self, atype, amode, increment=1.0)
| Method oriented to analyze choose models candidate and select analysis objective. More...
def | applicability (self, model_list, nrows, ncols)
| Method oriented to select applicability of models over min_rows_limit. More...
def | priorize_models (self, model_list)
| Method managing scoring algorithm results params: results for Handlers (gdayf.handlers) More...
def | generate_vectors (self, model, normalization_set)
| Store executed model base parameters to check past executions. More...
def | is_executed (self, vector)
| Check if model has benn executed or is planned to execute. More...
def | compare_vectors (vector1, vector2)
| Compare to execution vectors. More...
def | safe_append (self, model_list, model)
| Check if model is previously executed. More...

## Static Public Member Functions
def | get_train_accuracy (model)
| Method get train accuracy for generic model. More...
def | get_test_accuracy (model)
| Method get test accuracy for generic model. More...
def | get_combined_accuracy (model)
| Method get averaged train and test accuracy for generic model. More...
def | get_train_rmse (model)
| Method get rmse for generic model. More...
def | get_test_rmse (model)
| Method get test rmse for generic model. More...
def | get_cdistance (model)
| Method get clustering distance for generic model. More...
def | get_train_r2 (model)
| Method get train accuracy for generic model. More...
def | get_test_r2 (model)
| Method get test accuracy for generic model. More...

## Public Attributes
| timestamp
| an_objective
| deep_impact
| analysis_recommendation_order
| analyzed_models
| excluded_models
| next_analysis_list
| metric
| dataframe_name
| hash_dataframe
| deepness

## Static Public Attributes
int | deepness = 1

## Detailed Description

Class focused on execute A* based analysis on three modalities of working Fast: 1 level analysis over default parameters Normal: One A* analysis for all models based until max_deep with early_stopping Paranoiac: One A* algorithm per model analysis until max_deep without early stoping.

Definition at line 36 of file adviserbase.py.

## Constructor & Destructor Documentation

## ◆ __init__()

def gdayf.core.adviserbase.Adviser.__init__ | ( |  | self,
|  |  | e_c,
|  |  | deep_impact = `5`,
|  |  | metric = `'accuracy'`,
|  |  | dataframe_name = `''`,
|  |  | hash_dataframe = `''`
| ) |  |

Constructor.

Parameters

  self | object pointer
  e_c | context pointer
  deep_impact | A* max_deep
  metric | metrict for priorizing models ['accuracy', 'rmse', 'test_accuracy', 'combined'] on train
  dataframe_name | dataframe_name or id
  hash_dataframe | MD5 hash value

Definition at line 47 of file adviserbase.py.

## Member Function Documentation

## ◆ analysis_specific()

def gdayf.core.adviserbase.Adviser.analysis_specific | ( |  | self,
|  |  | dataframe_metadata,
|  |  | list_ar_metadata
| ) |  |

Method oriented to execute new analysis.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()j
  list_ar_metadata | List of ar json compatible model's descriptors

Returns
  analysis_id, Ordered[(algorithm_metadata.json, normalizations_sets.json)]

Definition at line 199 of file adviserbase.py.

Here is the call graph for this function:

## ◆ analysisanomalies()

def gdayf.core.adviserbase.Adviser.analysisanomalies | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode
| ) |  |

Method oriented to execute unsupervised anomalies models.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  amode | [ANOMALIES]
  objective_column | string indicating objective column

Returns
  analysis_id,(framework, Ordered[(algorithm_metadata.json, normalizations_sets.json)])

Definition at line 282 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ analysisclustering()

def gdayf.core.adviserbase.Adviser.analysisclustering | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode
| ) |  |

Method oriented to execute unsupervised clustering models.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  amode | [CLUSTERING]
  objective_column | string indicating objective column

Returns
  analysis_id,(framework, Ordered[(algorithm_metadata.json, normalizations_sets.json)])

Definition at line 323 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ analysisnormal()

def gdayf.core.adviserbase.Adviser.analysisnormal | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode
| ) |  |

Method oriented to execute smart normal and fast analysis.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  objective_column | string indicating objective column
  amode | [POC, NORMAL, FAST, PARANOIAC, FAST_PARANOIAC]

Returns
  analysis_id, Ordered[(algorithm_metadata.json, normalizations_sets.json)]

Definition at line 104 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ analysisparanoiac()

def gdayf.core.adviserbase.Adviser.analysisparanoiac | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode
| ) |  |

Method oriented to execute smart normal and fast analysis.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  amode | [POC, NORMAL, FAST, PARANOIAC, FAST_PARANOIAC]
  objective_column | string indicating objective column

Returns
  analysis_id,(framework, Ordered[(algorithm_metadata.json, normalizations_sets.json)])

Definition at line 241 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ analysispoc()

def gdayf.core.adviserbase.Adviser.analysispoc | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode
| ) |  |

Method oriented to execute poc analysis.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  objective_column | string indicating objective column
  amode | [POC, NORMAL, FAST, PARANOIAC, FAST_PARANOIAC]

Returns
  analysis_id, Ordered[(algorithm_metadata.json, normalizations_sets.json)]

Definition at line 172 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ applicability()

def gdayf.core.adviserbase.Adviser.applicability | ( |  | self,
|  |  | model_list,
|  |  | nrows,
|  |  | ncols
| ) |  |

Method oriented to select applicability of models over min_rows_limit.

Parameters

  self | object pointer
  model_list | List[ArMetadata]
  nrows | number of rows of dataframe
  ncols | number of cols of dataframe

Returns
  implicit List[ArMetadata]

Definition at line 561 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ base_iteration()

def gdayf.core.adviserbase.Adviser.base_iteration | ( |  | self,
|  |  | amode,
|  |  | dataframe_metadata,
|  |  | objective_column
| ) |  |

Method oriented to select initial candidate models.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  amode | [POC, NORMAL, FAST, PARANOIAC, FAST_PARANOIAC]
  objective_column | string indicating objective column

Definition at line 397 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ base_specific()

def gdayf.core.adviserbase.Adviser.base_specific | ( |  | self,
|  |  | dataframe_metadata,
|  |  | list_ar_metadata
| ) |  |

Method oriented to generate specific candidate metadata.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  list_ar_metadata |

Definition at line 361 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ compare_vectors()

def gdayf.core.adviserbase.Adviser.compare_vectors | ( |  | vector1,
|  |  | vector2
| ) |  |

Compare to execution vectors.

Parameters

  vector1 | - model_execution vector
  vector2 | - model_execution vector

Returns
  True if equal False if inequity

Definition at line 795 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ generate_vectors()

def gdayf.core.adviserbase.Adviser.generate_vectors | ( |  | self,
|  |  | model,
|  |  | normalization_set
| ) |  |

Store executed model base parameters to check past executions.

Parameters

  model | - ArMetadata to be stored as executed
  normalization_set |

Returns
  model_vector (fw, model_id, vector, normalizaton_set)

Definition at line 764 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_analysis_objective()

def gdayf.core.adviserbase.Adviser.get_analysis_objective | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | atype = `None`
| ) |  |

Method oriented to analyze DFmetadata and select analysis objective.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  objective_column | string indicating objective column
  atype | atypes constats or None

Returns
  ArType or None if objective_column not found

Definition at line 473 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_candidate_models()

def gdayf.core.adviserbase.Adviser.get_candidate_models | ( |  | self,
|  |  | atype,
|  |  | amode,
|  |  | increment = `1.0`
| ) |  |

Method oriented to analyze choose models candidate and select analysis objective.

Parameters

  self | object pointer
  atype | ATypesMetadata
  amode | Analysismode
  increment | increment x size

Returns
  FrameworkMetadata()

Definition at line 535 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ get_cdistance()

def gdayf.core.adviserbase.Adviser.get_cdistance | ( |  | model | ) |
| static

Method get clustering distance for generic model.

Parameters

  model |

Returns
  The Total Within Cluster Sum-of-Square Error metric, inverse The Between Cluster Sum-of-Square Error, objective or 10e+308, 0.0, objective if not exists

Definition at line 684 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_combined_accuracy()

def gdayf.core.adviserbase.Adviser.get_combined_accuracy | ( |  | model | ) |
| static

Method get averaged train and test accuracy for generic model.

Parameters

  model |

Returns
  accuracy metric, inverse rmse, objective or 0.0, 10e+308, objective if not exists

Definition at line 621 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_size_increment()

def gdayf.core.adviserbase.Adviser.get_size_increment | ( |  | self,
|  |  | df_metadata
| ) |  |

Method oriented to analyze get increments on effort based on DF_metadata structure.

Parameters

  self | object pointer
  df_metadata | DfMetada

Returns
  float increment

Definition at line 518 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_test_accuracy()

def gdayf.core.adviserbase.Adviser.get_test_accuracy | ( |  | model | ) |
| static

Method get test accuracy for generic model.

Parameters

  model |

Returns
  accuracy metric, inverse rmse, objective or 0.0, 10e+308, objective if not exists

Definition at line 603 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_test_r2()

def gdayf.core.adviserbase.Adviser.get_test_r2 | ( |  | model | ) |
| static

Method get test accuracy for generic model.

Parameters

  model |

Returns
  r2 metric, inverse rmse, objective or 0.0, 10e+308, objective if not exists

Definition at line 722 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_test_rmse()

def gdayf.core.adviserbase.Adviser.get_test_rmse | ( |  | model | ) |
| static

Method get test rmse for generic model.

Parameters

  model |

Returns
  rsme metric, inverse combined accuracy, objective or 10e+308, 0.0, objective if not exists

Definition at line 661 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_train_accuracy()

def gdayf.core.adviserbase.Adviser.get_train_accuracy | ( |  | model | ) |
| static

Method get train accuracy for generic model.

Parameters

  model |

Returns
  accuracy metric, inverse rmse, objective or 0.0, 10e+8, objective if not exists

Definition at line 585 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_train_r2()

def gdayf.core.adviserbase.Adviser.get_train_r2 | ( |  | model | ) |
| static

Method get train accuracy for generic model.

Parameters

  model |

Returns
  r2 metric, inverse rmse, objective or 0.0, 10e+8, objective if not exists

Definition at line 704 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ get_train_rmse()

def gdayf.core.adviserbase.Adviser.get_train_rmse | ( |  | model | ) |
| static

Method get rmse for generic model.

Parameters

  model |

Returns
  rsme metric, inverse combined accuracy, objective or 10e+308, 0.0, objective if not exists

Definition at line 639 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ is_executed()

def gdayf.core.adviserbase.Adviser.is_executed | ( |  | self,
|  |  | vector
| ) |  |

Check if model has benn executed or is planned to execute.

Parameters

  vector | - model vector

Returns
  True if executed False in other case

Definition at line 783 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ load_frameworks()

def gdayf.core.adviserbase.Adviser.load_frameworks | ( |  | self | ) |

Method oriented to get frameworks default values from config.

Parameters

  self | object pointer

Returns
  FrameWorkMetadata

Definition at line 464 of file adviserbase.py.

Here is the caller graph for this function:

## ◆ priorize_models()

def gdayf.core.adviserbase.Adviser.priorize_models | ( |  | self,
|  |  | model_list
| ) |  |

Method managing scoring algorithm results params: results for Handlers (gdayf.handlers)

Parameters

  model_list | for models analyzed

Returns
  (fw,model_list) (ArMetadata, normalization_set)

Definition at line 740 of file adviserbase.py.

Here is the call graph for this function:

## ◆ safe_append()

def gdayf.core.adviserbase.Adviser.safe_append | ( |  | self,
|  |  | model_list,
|  |  | model
| ) |  |

Check if model is previously executed.

If it not append to list

Parameters

  model_list |
  model | json compatible

Definition at line 802 of file adviserbase.py.

Here is the call graph for this function:
Here is the caller graph for this function:

## ◆ set_recommendations()

def gdayf.core.adviserbase.Adviser.set_recommendations | ( |  | self,
|  |  | dataframe_metadata,
|  |  | objective_column,
|  |  | amode = `POC`,
|  |  | atype = `None`
| ) |  |

Main method oriented to execute smart analysis.

Parameters

  self | object pointer
  dataframe_metadata | DFMetadata()
  amode | [POC, NORMAL, FAST, PARANOIAC, FAST_PARANOIAC]
  objective_column | string indicating objective column
  atype | atypes constats or None

Returns
  ArMetadata()'s Prioritized queue

Definition at line 72 of file adviserbase.py.

Here is the call graph for this function:

The documentation for this class was generated from the following file:

- D:/OneDrive/DayF/git/gdayf-core/src/gdayf/core/adviserbase.py